<template>
  <Error v-if="$fetchState.error" :error="$fetchState.error"></Error>
  <BaseBoard v-else pretitle="overview">
    <template #title-board>
      <h3
        class="page-title"
        data-hint="Your home page will feature"
        data-hintposition="top-left"
      >
        {{ 'Home' | capitalize }}
      </h3>
    </template>
    <template #header-right>
      <div v-if="dataLoaded" class="btn-list justify-content-end">
        <div class="d-none d-sm-inline">
          <a
            class="btn mr-1m rimow-step-by-step-guide mode-simple toggle-mode-visible visible cursor-pointer"
            @click="initIntro()"
          >
            <DirectionsIcon />
            Step-by-step guide
          </a>
        </div>
        <div class="d-none d-sm-inline">
          <b-nav-item
            to="/datasets"
            class="btn p-0 mr-1m rimow-step-by-step-guide mode-simple toggle-mode-visible visible"
          >
            <DatabaseIcon />
            Explore Datasets
          </b-nav-item>
        </div>
        <a
          v-b-modal.modal-create-project
          data-intro="Start by clicking here to create a new project!"
          href="#"
          class="btn btn-primary project-new d-none d-sm-inline-block"
        >
          <FolderPlusIcon />
          Start a new project
        </a>
      </div>
    </template>
    <template #content>
      <b-col>
        <b-row class="row-deck row-cards">
          <template v-if="!dataLoaded">
            <b-col v-for="n in 4" :key="n" sm="6" xl="3">
              <MiniCardSkeleton />
            </b-col>
          </template>
          <template v-else>
            <b-col
              v-for="card in stats.miniCards"
              :key="card.index"
              sm="6"
              xl="3"
            >
              <MiniCard
                :title="card.title"
                :subtitle="card.subtitle"
                :completed-steps="card.completedSteps"
              >
                <template #avatar>
                  <span class="text-white avatar" :class="card.bg">
                    <component :is="card.icon"></component>
                  </span>
                </template>
              </MiniCard>
            </b-col>
          </template>
          <template v-if="!dataLoaded">
            <h3>Loading home...</h3>
          </template>
          <template v-else>
            <b-col :sm="sizeCardProject.sm" :xl="sizeCardProject.xl">
              <ErrorProjectCard
                v-if="stats.projects.error || stats.jobs.error"
              ></ErrorProjectCard>
              <div v-else class="w-100">
                <ProjectCard
                  v-if="stats.last_project"
                  :project="stats.last_project"
                >
                  <template #avatarLetter>
                    <span
                      class="avatar avatar-xl mb-4 align-self-center avatar-rounded"
                      >{{ stats.last_project.title | wordInitialLetter }}</span
                    >
                  </template>
                  <template #hint>
                    <div
                      class="position-relative"
                      style="top: -10px"
                      data-hint="Click here to show available actions for this project"
                      data-hintposition="top-right"
                    ></div>
                  </template>
                  <template #card-title>
                    <h3 class="card-title">
                      <ClockIcon class="text-gray" />
                      Latest project
                    </h3>
                  </template>
                </ProjectCard>
                <InviteFirstProject v-else />
              </div>
            </b-col>
            <b-col v-if="stats.project_most_used" sm="6" xl="3">
              <ProjectCard :project="stats.project_most_used">
                <template #avatarLetter>
                  <span
                    class="avatar avatar-xl mb-4 align-self-center bg-green-lt avatar-rounded"
                    >{{
                      stats.project_most_used.title | wordInitialLetter
                    }}</span
                  >
                </template>
                <template #card-title>
                  <h3 class="card-title">
                    <ArchiveIcon class="text-gray" />
                    Most used
                  </h3>
                </template>
              </ProjectCard>
            </b-col>
            <b-col sm="12" xl="6">
              <CreateDataset />
            </b-col>
          </template>
        </b-row>
      </b-col>
    </template>
  </BaseBoard>
</template>

<script>
import { mapGetters } from 'vuex';
import notificationsMixin from '~/mixins/notifications.js';
export default {
  mixins: [notificationsMixin],
  layout: 'dashboard',
  middleware: 'auth',
  async fetch() {
    await this.$nuxt.context.store.dispatch('user/getUserStats').catch(() => {
      this.showErrorNotification('Error getting user stats');
    });
  },
  head() {
    return {
      title: 'Home - RISIS Workspace',
    };
  },
  computed: {
    ...mapGetters({
      stats: 'user/stats',
    }),
    dataLoaded() {
      return Object.keys(this.stats).length > 0;
    },
    sizeCardProject() {
      return !this.stats.project_most_used && !this.stats.last_project
        ? { sm: '12', xl: '6' }
        : { sm: '6', xl: '3' };
    },
  },
  methods: {
    initIntro() {
      this.$store.commit('ui/showIntroJs');
    },
  },
};
</script>
